
Core - Bug # 53556

Epic # 55070 (Accepted): Workpackages
Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)
Bug # 52949 (Resolved): Speed decrease since 4.5

Status: Closed Priority: Should have
Author: Ingo Schmitt Category: Performance
Created: 2013-11-12 Assigned To:
Updated: 2014-01-27 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity: easy
Is Regression: No
Sprint Focus:
Subject: classLoader->loadClass calls requireOnce twice per class
Description

Inside classLoad->LoadClass each class is loaded in line 134, but again in line 156.

134:
1// Loads any known class via caching framework
2        if ($require) {
3            if ($this->classesCache->requireOnce($cacheEntryIdentifier) !== FALSE) {
4                $cacheEntryCreated = TRUE;
5            }
6        }

156:
1        if ($cacheEntryCreated && $require) {
2            if ($this->classesCache->requireOnce($cacheEntryIdentifier) !== FALSE) {
3                $cacheEntryCreated = TRUE;
4            }
5        }

By looking into the logic, it seams if a require was successful in the first part, the require is repeated in the second part. You could
speed it up by checking if the require was successful in the first part and avoid the second require.

Related issues:
related to Core - Task # 53744: Change ClassLoader cache from proxy require f... Resolved 2013-11-18

History
#1 - 2013-11-12 13:11 - Ingo Schmitt

I'll post a patch at gerrit

#2 - 2013-11-12 13:52 - Gerrit Code Review
- Status changed from New to Under Review
Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25305

#3 - 2013-11-21 11:49 - Ernesto Baschny
- Parent task set to #52949

#4 - 2013-11-21 18:22 - Thorsten Kahler
- Complexity set to easy

I realized that some time ago, too.

#5 - 2013-11-21 18:37 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/25305

#6 - 2013-12-01 18:02 - Wouter Wolters
- Status changed from Under Review to Closed

Not needed anymore. Closed.

#7 - 2014-01-27 10:22 - Ingo Schmitt
- % Done changed from 0 to 100
